/* Gossip header file */

#ifdef GOSSIP_H
#else
#define GOSSIP_H

#include <time.h>
#include <config.h>

/* Vars */
struct client {
  int socket;
  int loggedin;
  int relaylogs;
  time_t logintime;
  time_t lasttime;
  char ip[16];
};

extern int errno;

#ifdef GOSSIP
  int do_daemonize=0;	/* Should GOSSIP daemonize?		*/
  int do_checklogfiles;	/* If this is 1, gossip checks for new  */
			/* logfiles. Should be set every now    */
			/* and then.				*/
  int sockets[2];         /* Array of sockets                     */
                        /* 0 is for connection with GO,         */
                        /* 1 is for listen()                    */
  int do_logrelay;	                                                
  struct client clients[MAXADMINS];       /* Array holding client-info   */
#else
  extern int do_daemonize;
  extern int do_checklogfiles;
  extern int do_logrelay;
  extern int sockets[2];
  extern struct client clients[MAXADMINS];
#endif

/* Functions */
int 	do_listen(void);
void 	usage(char *pgm);
void 	init(void);
int 	daemonize(void);
void 	handle_alarm(int sig);
int	handle_gossipcommand(int client, char *buf, int bufsize);
void	handle_logrelay(void);

#endif
