#define CONFIGS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <config.h>
#include <configs.h>
#include <logger.h>
#include <misc.h>

/* Parse GOSSIP configfile */   
void do_config(void) {
   FILE *fd;
   char inputbuffer [BUFSIZ];
   char tempbuffer [BUFSIZ];
   int tempint;
     
   /* Clear configurables */
   listenport=0;
   memset(adminaddress,0,sizeof(adminaddress));
   memset(adminpass,0,sizeof(adminpass));
   adminport=0;
   listenport=0;
   login_timeout=0;
   inactivity_timeout=0;
         
   /* Open config file */
   if ((fd=fopen(CONFIGFILE,"r"))==NULL) {
   	log(LOGGER_ERROR,"Could not open GOSSIP configfile: %s",strerror(errno));
   	exit(1);
   }
   
   /* Read and parse config file */
   while (fgets(inputbuffer,sizeof(inputbuffer),fd)!=NULL) {

      /* Filter '\n' and skip empty lines or lines starting with '#' */
      inputbuffer[strlen(inputbuffer)-1]='\0';
      if (strlen(inputbuffer)==0 || inputbuffer[0]=='#') continue;	            

      /* Parse */
      if (sscanf(inputbuffer,"adminpass=%s",tempbuffer)==1) {
         strncpy(adminpass,tempbuffer,sizeof(adminpass));
      }	
      if (sscanf(inputbuffer,"adminaddress=%s",tempbuffer)==1) {
      	 strncpy(adminaddress,tempbuffer,sizeof(adminaddress));
      }
      if (sscanf(inputbuffer,"logdirectory=%s",tempbuffer)==1) {
      	 strncpy(logdirectory,tempbuffer,sizeof(logdirectory));
      }
 
      if (sscanf(inputbuffer,"adminport=%d",&tempint)==1) {
	if (tempint>0 && tempint <= 65535) {
	   adminport=tempint;
	} else {
	   log(LOGGER_ERROR,"Adminport %d is invalid",tempint);
	   exit(1); 
	}
      }

      if (sscanf(inputbuffer,"listenport=%d",&tempint)==1) {
	if (tempint>0 && tempint <= 65535) { 
	   listenport=tempint; 
	} else {
	   log(LOGGER_ERROR,"Listenport %d is invalid",tempint);
	   exit(1);
	}
      }

      if (sscanf(inputbuffer,"login_timeout=%d",&tempint)==1) {
         login_timeout=tempint;
      }
      
      if (sscanf(inputbuffer,"inactivity_timeout=%d",&tempint)==1) {
      	 inactivity_timeout=tempint;
      }

      if (sscanf(inputbuffer,"connects_per_ip=%d",&tempint)==1) {
         if (tempint>0) connects_per_ip=tempint; 
         else {
            log(LOGGER_ERROR,"Connects per IP %d is invalid",tempint);
            exit(1);   
         }
      }
   }
   fclose(fd);
}



              